Parameters:
  ProjectName:
    Description: The name of the project.
    Type: String
  Node1AMI:
    Type: AWS::EC2::Image::Id
    Description: Amazon Image ID for Node1
    Default: 'ami-03f6a11788f8e319e'
  Node1InstanceClass:
    Type: String
    Description: Instance Class for Node1
    Default: 't2.xlarge'
  RSAKeyName:
    Type: String
    Description: Put the Name for RSA Key Pair
  DeployEnv:
    Type: String
    Default: "nonprod"
    AllowedValues:
      - "nonprod"
      - "prod"

Resources:
  RSAKeyPair:
    Type: AWS::EC2::KeyPair
    Properties: 
      KeyName: !Sub  "${DeployEnv}-${ProjectName}-${RSAKeyName}"
      KeyType: rsa
      Tags: 
        - 
          Key: env
          Value: !Sub "${DeployEnv}-keypair"
  
  Node1:
    Type: AWS::EC2::Instance
    Properties:
      BlockDeviceMappings:
        - DeviceName: /dev/xvda
          Ebs:
            VolumeSize: 40
            VolumeType: gp3
            Encrypted: false
      DisableApiTermination: false
      SubnetId:
        'Fn::ImportValue': !Sub "${DeployEnv}-${ProjectName}-PublicSubnet1"
      SecurityGroupIds:
        - 'Fn::ImportValue': !Sub "${DeployEnv}-${ProjectName}-node1-sg"
      ImageId: !Ref Node1AMI
      InstanceType: !Ref Node1InstanceClass
      KeyName: !Ref RSAKeyPair
      Tags: 
        -
          Key: env
          Value: !Sub "${DeployEnv}"
        -
          Key: service
          Value: K8Snode1
        -
          Key: Name
          Value: !Sub "${DeployEnv}-${ProjectName}-Node1"
      Tenancy: default 